// https://www.digitalocean.com/community/tutorials/initialize-an-array-in-c

#include<stdio.h>

void wypisz_10(int a[10]) {
    for(int i=0;i<10;i++) {
        if (i>0) printf(" ");
        printf("%d", a[i]);
    }
    printf("\n");
}

void wypisz(int a[], int n) {
    for(int i=0;i<n;i++) {
        if (i>0) printf(" ");
        printf("%d", a[i]);
    }
    printf("\n");
}

void wypisz_const(const int a[], int n) {
    // dzieki const zabroniona jest modyfikacja a
    // a[0] = 1; <- to się nie skompiluje
    for(int i=0;i<n;i++) {
        if (i>0) printf(" ");
        printf("%d", a[i]);
    }
    printf("\n");
}

void wypisz_wsk(int *a, int n) {
    for(int i=0;i<n;i++) {
        if (i>0) printf(" ");
        printf("%d", a[i]);
    }
    printf("\n");
}

void wypelnij(int a[], int n) {
    for(int i=0;i<n;i++) a[i] = i+1;
}

int main(void) {
    int arr1[10] = {0};
    wypisz_10(arr1); // 0 0 0 ...
    //int arr_za_krotka[5] = {0};
    //wypisz_10(arr_za_krotka);

    int arr2[20] = {1};
    wypisz_10(arr2); // 1 0 0 ...
    int arr3[15] = {1, 2, 3};
    wypisz_10(arr3); // 1 2 3 0 0 ...

    int arr5[] = {1, 2, 3, 4, 5};
    wypisz(arr5, 5); // 1 2 3 4 5

    // to nie skompiluje się z -pedantic
    // int arr10[10] = {[3 ... 5] = 42};
    // wypisz(arr10, 10); // 0 0 0 42 42 42 0 0 0 0 0

    wypelnij(arr1, 5);
    wypisz_10(arr1); // 1 2 3 4 5 0 0
    wypisz(arr1, 10); // 1 2 3 4 5 0 0
    wypisz_const(arr1, 10); // 1 2 3 4 5 0 0
    wypisz_wsk(arr1, 10); // 1 2 3 4 5 0 0
}
